## Driver capabilities at a glance:

### Networking capable:

| Processor ->                          | [iMXRT1062](https://github.com/grblHAL/iMXRT1062) | [STM32F7xx](https://github.com/grblHAL/STM32F7xx) | [STM32H7xx](https://github.com/dresco/STM32H7xx) | [ESP32](https://github.com/grblHAL/ESP32) | [RP&nbsp;2040](https://github.com/grblHAL/RP2040)<sup>4</sup> | [RP&nbsp;2040](https://github.com/grblHAL/RP2040)<sup>4</sup> | [MSP432E401Y](https://github.com/grblHAL/MSP432E401Y) | [TMC129x](https://github.com/grblHAL/TM4C1294) |
|---------------------------------------|---------------------------------------------------|---------------------------------------------------|--------------------------------------------------|-------------------------------------------|---------------------------------------------------------------|---------------------------------------------------------------|-------------------------------------------------------|------------------------------------------------|
| Board                                 | Teensy 4.x                                        | Nucleo-F756ZG                                     | Nucleo-H743ZI                                    |                                           | Pi Pico W                                                     | Pi Pico                                                       | LaunchPad                                             | LaunchPad                                      |
| MCU speed \(MHz\)                     | 600                                               | 216                                               | 450                                              | 2x240                                     | 125                                                           | 125                                                           | 120                                                   | 120                                            |
| Floating point unit \(FPU\)           | yes                                               | yes                                               | yes                                              | yes                                       | no                                                            | no                                                            | yes                                                   | yes                                            |
| Non-volatile storage                  | Flash<sup>1</sup>                                 | Flash<sup>1</sup>                                 | Flash<sup>1</sup>                                | Flash<sup>1</sup>                         | Flash<sup>1</sup>                                             | Flash<sup>1</sup>                                             | EEPROM                                                | EEPROM                                         |
| Number of axes                        | up to 5                                           | up to 8                                           | up to 8                                  | 3                                         | up to 6                                                       | up to 6                                                       | up to 6                                               | up to 6                                        |
| Auto-squared/ganged axes<sup>17</sup> | yes                                               | yes                                               | no                                               | no                                        | yes                                                           | yes                                                           | no                                                    | no                                             |
| Variable spindle                      | yes                                               | yes                                               | yes                                              | yes                                       | yes                                                           | yes                                                           | yes                                                   | yes                                            |
| Ramped spindle                        | no                                                | no                                                | no                                               | yes                                       | no                                                            | no                                                            | yes                                                   | yes                                            |
| Inverted spindle PWM                  | yes                                               | yes                                               | yes                                              | yes                                       | yes                                                           | yes                                                           | yes                                                   | yes                                            |
| RC Servo/ESC for spindle<sup>13</sup> | yes                                               | yes                                               | yes                                              | yes                                       | yes                                                           | yes                                                           | yes                                                   | yes                                            |
| ModBus spindle<sup>14</sup>           | yes<sup>15</sup>                                  | no                                                | no                                               | yes                                       | yes                                                           | yes                                                           | no                                                    | no                                             |
| Spindle at speed                      | yes                                               | yes                                               | yes                                              | no                                        | no                                                            | no                                                            | no                                                    | no                                             |
| Spindle sync                          | yes<sup>4</sup>                                   | yes                                               | yes                                              | no                                        | no                                                            | no                                                            | no                                                    | no                                             |
| Closed loop spindle RPM               | no                                                | no                                                | no                                               | no                                        | no                                                            | no                                                            | no                                                    | no                                             |
| Native USB streaming                  | yes                                               | yes                                               | yes                                              | no                                        | yes                                                           | yes                                                           | no                                                    | no                                             |
| Bluetooth streaming                   | no                                                | no                                                | no                                               | yes                                       | yes                                                           | yes                                                           | no                                                    | no                                             |
| Telnet streaming \(raw\)              | ethernet                                          | ethernet                                          | ethernet                                         | wifi                                      | wifi/ethernet<sup>18</sup>                                    | ethernet<sup>18</sup>                                         | ethernet                                              | ethernet                                       |
| Websocket streaming                   | ethernet                                          | ethernet                                          | ethernet                                         | wifi                                      | wifi/ethernet<sup>18</sup>                                    | ethernet<sup>18</sup>                                         | ethernet                                              | ethernet                                       |
| HTTP daemon (server)                  | ethernet                                          | ethernet                                          | ethernet                                         | wifi                                      | wifi/ethernet<sup>18</sup>                                    | ethernet<sup>18</sup>                                         | ethernet                                              | ethernet                                       |
| WebDAV to SD&nbsp;card                | ethernet                                          | ethernet                                          | ethernet                                         | wifi                                      | wifi/ethernet<sup>18</sup>                                    | ethernet<sup>18</sup>                                         | ethernet                                              | no (\?\)                                       |
| FTP to SD&nbsp;card                   | ethernet                                          | ethernet                                          | ethernet                                         | wifi                                      | wifi/ethernet<sup>18</sup>                                    | ethernet<sup>18</sup>                                         | ethernet                                              | no (\?\)                                       |
| SD Card streaming                     | yes                                               | yes                                               | yes                                              | yes                                       | yes                                                           | yes                                                           | no                                                    | no                                             |
| I2C Keypad                            | yes                                               | yes                                               | yes                                              | yes                                       | yes                                                           | yes                                                           | no                                                    | no                                             |
| I2C IO Expander                       | no                                                | no                                                | no                                               | yes                                       | yes                                                           | yes                                                           | no                                                    | no                                             |
| Digital Aux I/O                       | 3/4<sup>16</sup>                                  | yes                                               | yes                                              | no                                        | 0/8<sup>16</sup>                                              | 0/8<sup>16</sup>                                              | no                                                    | no                                             |
| MPG stream input                      | TBC                                               | no                                                | no                                               | no                                        | yes                                                           | yes                                                           | yes                                                   | yes                                            |
| Manual tool change<sup>5</sup>        | yes                                               | yes                                               | yes                                              | yes                                       | yes                                                           | yes                                                           | yes                                                   | yes                                            |
| Automatic tool change<sup>6</sup>     | no                                                | no                                                | no                                               | no                                        | no                                                            | no                                                            | no                                                    | no                                             |
| Laser PPI mode<sup>7</sup>            | yes                                               | yes                                               | yes                                              | no                                        | no                                                            | no                                                            | no                                                    | no                                             |
| Trinamic support<sup>8</sup>          | TBC<sup>9</sup>                                   | TBC<sup>9</sup>                                   | TBC<sup>9</sup>                                  | TBC<sup>9</sup>                           | TBC<sup>9</sup>                                               | TBC<sup>9</sup>                                               | TBC<sup>9</sup>                                       | TBC<sup>9</sup>                                |
| Runs as FreeRTOS task                 | no                                                | no                                                | no                                               | yes                                       | no                                                            | no                                                            | option                                                | no                                             |
| CNC BoosterPack support               | yes<sup>10</sup>                                  | no                                                | no                                               | yes<sup>10</sup>                          | yes<sup>10</sup>                                              | yes<sup>10</sup>                                              | 2                                                     | 2                                              |
| WebUI support                         | yes<sup>12</sup>                                  | yes<sup>12</sup>                                  | yes<sup>12</sup>                                 | yes<sup>12</sup>                          | yes<sup>12</sup>                                              | yes<sup>12</sup>                                              | yes<sup>12</sup>                                      | no                                             |
| Compiler/IDE                          | Arduino                                           | STMCubeIDE                                        | STMCubeIDE                                       | ESP IDF                                   | VS Code                                                       | VS Code                                                       | CCS                                                   | CCS                                            |
| Web Builder support<sup>19</sup>      | yes                                               | yes                                               | yes                                              | yes                                       | yes                                                           | yes                                                           | no                                                    | no                                             |

### With floating point unit \(FPU\):

grblHAL does a lot of floating point math, a FPU will improve performance.

| Processor ->                          | [STM32F7xx](https://github.com/dresco/STM32H7xx) | [STM32F4xx](https://github.com/grblHAL/STM32F4xx) | [STM32F3xx](https://github.com/grblHAL/STM32F3xx) | [MSP432](https://github.com/grblHAL/MSP432P401R) | [TMC123](https://github.com/grblHAL/TM4C123) |
|---------------------------------------|--------------------------------------------------|---------------------------------------------------|---------------------------------------------------|--------------------------------------------------|----------------------------------------------|
| Board                                 | BTT SKR3 / WeAct MiniSTM32H743                   | Blackpill / Nucleo-F411RE / Nucleo-F446RE         | BlackPill                                         | LaunchPad                                        | LaunchPad                                    |
| MCU speed \(MHz\)                     | 450                                              | 84/100/180                                        | 72                                                | 48                                               | 80                                           |
| Non-volatile storage                  | Flash<sup>1</sup>                                | Flash<sup>1</sup>                                 | Flash<sup>1</sup>                                 | Flash<sup>1</sup>                                | EEPROM                                       |
| Number of axes                        | 3                                                | up to 6                                           | up to 6                                           | 3                                                | 3                                            |
| Variable spindle                      | yes                                              | yes                                               | yes                                               | yes                                              | yes                                          |
| Ramped spindle                        | no                                               | no                                                | no                                                | no                                               | yes                                          |
| Inverted spindle PWM                  | no                                               | no                                                | no                                                | yes                                              | yes                                          |
| RC Servo/ESC for spindle<sup>13</sup> | yes                                              | yes                                               | yes                                               | yes                                              | yes                                          |
| ModBus spindle<sup>14</sup>           | no                                               | no                                                | no                                                | yes<sup>15</sup>                                 | no                                           |
| Spindle at speed                      | yes                                              | yes                                               | no                                                | yes<sup>3</sup>                                  | no                                           |
| Spindle sync                          | yes<sup>4</sup>                                  | yes<sup>4</sup>                                   | no                                                | yes<sup>4</sup>                                  | no                                           |
| Closed loop spindle RPM               | no                                               | no                                                | no                                                | no                                               | no                                           |
| Native USB streaming                  | yes                                              | yes                                               | yes                                               | no                                               | no                                           |
| SD Card streaming                     | yes                                              | yes                                               | TBC                                               | no                                               | yes                                          |
| I2C Keypad                            | no                                               | no                                                | yes                                               | yes                                              | yes                                          |
| I2C IO Expander                       | no                                               | no                                                | no                                                | no                                               | no                                           |
| Digital Aux I/O                       | no                                               | 2/2<sup>16</sup>                                  | no                                                | no                                               | no                                           |
| MPG stream input                      | no                                               | no                                                | no                                                | yes                                              | yes                                          |
| Manual tool change<sup>5</sup>        | yes                                              | yes                                               | yes                                               | yes                                              | yes                                          |
| Automatic tool change<sup>6</sup>     | no                                               | no                                                | no                                                | planned                                          | no                                           |
| Laser PPI mode<sup>7</sup>            | yes                                              | yes                                               | no                                                | no                                               | yes                                          |
| Trinamic support<sup>8</sup>          | TBC<sup>9</sup>                                  | TBC<sup>9</sup>                                   | TBC<sup>9</sup>                                   | TBC<sup>9</sup>                                  | TBC<sup>9</sup>                              |
| CNC BoosterPack support               | no                                               | no                                                | yes<sup>10</sup>                                  | 1                                                | 1                                            |
| Compiler/IDE                          | STMCubeIDE                                       | STMCubeIDE                                        | STMCubeIDE                                        | CCS                                              | CCS                                          |
| Web Builder support<sup>19</sup>      | yes                                              | yes                                               | No                                                | no                                               | no                                           |

### Without floating point unit \(FPU\):

| Processor ->                          | [RP&nbsp;2040](https://github.com/grblHAL/RP2040)<sup>4</sup> | [STM32F1xx](https://github.com/grblHAL/STM32F1xx)<sup>11</sup> | [SAM3X8E](https://github.com/grblHAL/SAM3X8E) | [SAMD21](https://github.com/grblHAL/SAMD21) | [LPC1768/1769](https://github.com/grblHAL/LPC176x) | [PSoC&nbsp;5](https://github.com/grblHAL/PSoC5) | [MSP430F5529](https://github.com/grblHAL/MSP430F5529) |
|---------------------------------------|---------------------------------------------------------------|----------------------------------------------------------------|-----------------------------------------------|---------------------------------------------|----------------------------------------------------|-------------------------------------------------|-------------------------------------------------------|
| Board                                 | Pi Pico                                                       | Bluepill                                                       | Due                                           | MKRZERO                                     | Re-Arm / Bigtreetech SKR 1.3 / BTT SKR 1.4         | CY8CKIT-059                                     | LaunchPad                                             |
| MCU speed (MHz)                       | 125                                                           | 72                                                             | 84                                            | 48                                          | 100/120                                            | 80                                              | 25 (16 bit)                                           |
| Non-volatile storage                  | Flash<sup>1</sup>                                             | Flash<sup>1</sup>                                              | Flash<sup>1</sup>                             | Flash<sup>1</sup>                           | Flash<sup>1</sup>                                  | EEPROM                                          | no<sup>1</sup>                                        |
| Number of axes                        | up to 6                                                       | up to 6                                                        | up to 6                                       | 3                                           | up to 5                                            | 3<sup>2</sup>                                   | 3                                                     |
| Auto-squared/ganged axes<sup>17</sup> | yes                                                           | yes                                                            | yes                                           | no                                          | yes                                                | no                                              | no                                                    |
| Variable spindle                      | yes                                                           | yes                                                            | yes                                           | yes                                         | yes                                                | yes                                             | yes                                                   |
| Ramped spindle                        | no                                                            | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Inverted spindle PWM                  | yes                                                           | yes                                                            | no                                            | no                                          | no                                                 | no                                              | yes                                                   |
| RC Servo/ESC for spindle<sup>13</sup> | yes                                                           | yes                                                            | yes                                           | yes                                         | yes                                                | no                                              | yes                                                   |
| ModBus spindle<sup>14</sup>           | yes                                                           | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Spindle at speed                      | no                                                            | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Spindle sync                          | no                                                            | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Closed loop spindle RPM               | no                                                            | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Native USB streaming                  | yes                                                           | yes                                                            | yes                                           | yes                                         | yes                                                | no                                              | no                                                    |
| SD Card streaming                     | yes                                                           | yes                                                            | no                                            | yes                                         | yes                                                | no                                              | no                                                    |
| I2C Keypad                            | yes                                                           | yes                                                            | no                                            | yes                                         | no                                                 | yes                                             | no                                                    |
| I2C IO Expander                       | yes                                                           | no                                                             | no                                            | yes                                         | no                                                 | no                                              | no                                                    |
| Digital Aux I/O                       | 0/8<sup>16</sup>                                              | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| MPG stream input                      | yes                                                           | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Manual tool change<sup>5</sup>        | yes                                                           | yes                                                            | yes                                           | yes                                         | yes                                                | yes                                             | no                                                    |
| Automatic tool change<sup>6</sup>     | no                                                            | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Laser PPI mode<sup>7</sup>            | no                                                            | no                                                             | no                                            | no                                          | no                                                 | no                                              | no                                                    |
| Trinamic support<sup>8</sup>          | TBC<sup>9</sup>                                               | TBC<sup>9</sup>                                                | TBC<sup>9</sup>                               | TBC<sup>9</sup>                             | no                                                 | no                                              | no                                                    |
| CNC BoosterPack support               | yes<sup>10</sup>                                              | yes<sup>10</sup>                                               | no                                            | yes<sup>10</sup>                            | no                                                 | no                                              | 1                                                     |
| Compiler/IDE                          | VS Code                                                       | STMCubeIDE                                                     | Arduino                                       | Arduino                                     | MCUExpresso                                        | PSOC Creator                                    | CCS                                                   |
| Web Builder support<sup>19</sup>      | yes                                                           | yes                                                            | yes                                           | no                                          | no                                                 | no                                              | no                                                    |

<br><sup>1</sup> Plugin for I2C EEPROM or FRAM available. FRAM is faster and can sustain more write cycles than EEPROM. FRAM is reccomended for the [Odometer plugin](https://github.com/grblHAL/Plugin_odometer).
<br><sup>2</sup> Should be fairly easy to extend.
<br><sup>3</sup> In combination with ramped spindle, signals end of ramp - not programmed speed obtained.
<br><sup>4</sup> To be completed \(TBC\), work in good progress.
<br><sup>5</sup> Protocol extension, requires compatible GCode sender such as [ioSender](https://github.com/terjeio/ioSender).
<br><sup>6</sup> grblHAL core has functionality and HAL driver entry points are provided, needs verification!
<br><sup>7</sup> Driver specific M codes added for control. PPI = Pulses Per Inch.
<br><sup>8</sup> Initial version ready for TMC2130 drivers, new [CNC BoosterPack](https://github.com/terjeio/CNC_Boosterpack) design for Texas Instrument LaunchPads ready and initial testing ok.
<br><sup>9</sup> Implementation provided for TMC2130, with initial focus on [I2C](https://github.com/terjeio/Trinamic_TMC2130_I2C_SPI_Bridge) interfaces. Work in good progress - code published.
<br><sup>10</sup> Via "motherboard" that accommodates [CNC BoosterPack](https://github.com/terjeio/CNC_Boosterpack) and processor board. Prototypes made, includes 8-bit I2C GPIO expander \(not available/needed for STM32F1xx or IMXRT1062\). "motherboards" has option for isolated level-shifted spindle PWM or DC output.  BoosterPack has an onboard EEPROM and an I2C level shifter.
<br><sup>11</sup> Requires 128KB of flash \(STM32F103CB\), some STM32F103C8 based Bluepill boards has that. Not recommended due to limited memories, use a STM32F303 or STM32F411 based Blackpill instead for a board with the same form factor as Red- and Bluepills. 
<br><sup>12</sup> Luc's [ESP3D-WEBUI](https://github.com/luc-github/ESP3D-webui). Support both v2 and v3, with auto-detect feature. 
<br><sup>13</sup> Set `$33=50` (PWM frequency), `$34=5`, `$35=5` and `$36=10` to generate a "standard" PWM signal: 20ms repetition rate, 1 - 2ms pulse length range. 
<br><sup>14</sup> [Supports a number of VFDs](https://github.com/grblHAL/Plugins_spindle/). Defaults to 19200 baud, implicit spindle at speed. Not supported for all alternative board map files. 
<br><sup>15</sup> Auto direction detect only. 
<br><sup>16</sup> Dependent on breakout board and plugin configuration.
<br><sup>17</sup> Dependent on breakout board capability. ABC motors will be added from the first motor available and upward, auto-squared/ganged motors from the last and downward.
<br><sup>18</sup> Ethernet is via SPI interface to an external WizNet W5100S or W5500 module. Not necessarily supported by all boards.
<br><sup>19</sup> The [Web Builder](http://svn.io-engineering.com:8080) can be used to create the firmware without installing a toolchain.

Please note that some of the capabilities should be fairly easy to port from one driver to another, but be aware some are dependent on MCU peripheral availability and thus not possible, or hard, to port.

The fastest and most deterministic MCUs seems to be iMRXT1062, STM32H7xx and STM32F7, ESP32 is not bad but it is a bit unstable - maybe due to outstanding [bugs](https://github.com/espressif/esp-idf/issues) in the [ESP-IDF](https://github.com/espressif/esp-idf) and the system architecture - program code is stored off chip in external serial flash.

---

Excel tables to markdown done with [thisDaveJ](https://thisdavej.com/copy-table-in-excel-and-paste-as-a-markdown-table/) web-based utility.

---
2024-01-15
